package com.simuwang.base.common.enums;

import java.util.stream.Stream;

/**
 * FileName: DistributeType
 * Author:   chenjianhua
 * Date:     2024/9/16 13:30
 * Description: ${DESCRIPTION}
 */
public enum SourceType {
    //单位分红/拆分比例
    DISTRIBUTION_REPORT(2, "分红公告"), MANAGER_REVIEW(1, "管理人确认"),OTHER(0,"其他"),SYSTEM_COMPUTE(3,"系统计算");

    private final Integer code;
    private final String info;

    SourceType(Integer code, String info) {
        this.code = code;
        this.info = info;
    }

    public static SourceType getSourceTypeByCode(Integer code) {
        if (null == code){
            return null;
        }
        for(SourceType s : SourceType.values()){
            if(code.equals(s.getCode())){
                return s;
            }
        }
        return null;
    }

    public static SourceType getSourceTypeByInfo(String info) {
        return Stream.of(SourceType.values()).filter(e -> e.info.equals(info)).findFirst().orElse(OTHER);
    }

    public Integer getCode() {
        return code;
    }

    public String getInfo() {
        return info;
    }
}
